var React = require('react');
var Icon = require('./icon.js');

var RestartButton = React.createClass({displayName: "RestartButton",
    
    render: function() {
        return (
            React.createElement("button", {type: "button", "data-player": "restart", onClick: this.props.handleSeek}, 
                React.createElement(Icon, {name: "icon-restart"}), 
                React.createElement("span", {className: "sr-only"}, "Restart")
            )
        );
    }

});

var RewindButton = React.createClass({displayName: "RewindButton",
    
    render: function() {
        return (
            React.createElement("button", {type: "button", "data-player": "rewind", onClick: this.props.handleRewind}, 
                React.createElement(Icon, {name: "icon-rewind"}), 
                React.createElement("span", {className: "sr-only"}, "Rewind 10 secs")
            )
        );
    }

});

var PlayButton = React.createClass({displayName: "PlayButton",

    handleToggle: function() {
        var node = this.getDOMNode();
        this.props.handleTogglePlayback();
        setTimeout(function() { node.focus(); }, 100);
    },

    render: function() {
        var name = this.props.playing ? "icon-pause" : "icon-play";
        var state = this.props.playing ? "pause" : "play";
        return (
            React.createElement("button", {type: "button", "data-player": state, onClick: this.props.handleTogglePlayback}, 
                React.createElement(Icon, {name: name})
            )
        );
    }

});

var FastForwardButton = React.createClass({displayName: "FastForwardButton",
    
    render: function() {
        return (
            React.createElement("button", {type: "button", "data-player": "fast-forward", onClick: this.props.handleForward}, 
                React.createElement(Icon, {name: "icon-fast-forward"}), 
                React.createElement("span", {className: "sr-only"}, "Forward 10 secs")
            )
        );
    }
});

var MuteButton = React.createClass({displayName: "MuteButton",

    toggleMute: function() {
        this.props.toggleMute(!this.props.muted);
    },

    render: function() {
        var name;
        if(this.props.muted) {
            name = "icon-muted"
        } else {
            name = "icon-volume"
        };
        return (
            React.createElement("button", {type: "button", "data-player": "mute", onClick: this.toggleMute}, 
                React.createElement(Icon, {name: name, className: name})
            )
        );
    }
});

var VolumeControl = React.createClass({displayName: "VolumeControl",

    changeVolume: function(e) {
        this.props.setVolume(e.target.value);
    },

    render: function() {
        return (
            React.createElement("input", {id: "volume", className: "player-volume", onChange: this.changeVolume, value: this.props.volumeLevel, type: "range", min: "0", max: "1", defaultValue: "0.5", step: "0.01", 
                "data-player": "volume"})
        );
    }
});

var FullScreenButton = React.createClass({displayName: "FullScreenButton",

    toggleFullScreen: function(event) {
        this.props.onToggleFullScreen(event);
    },

    render: function() {
        var name;
        if(this.props.fullScreen) {
            name = "icon-exit-fullscreen"
        } else {
            name = "icon-enter-fullscreen"
        };
        return (
            React.createElement("button", {type: "button", "data-player": "fullscreen", onClick: this.toggleFullScreen}, 
                React.createElement(Icon, {name: name})
            )
        );
    }

});

module.exports = {
    RestartButton: RestartButton,
    RewindButton: RewindButton,
    PlayButton: PlayButton,
    FastForwardButton: FastForwardButton,
    MuteButton: MuteButton,
    VolumeControl: VolumeControl,
    FullScreenButton: FullScreenButton,
};
