var gulp = require('gulp');
var react = require('gulp-react');
var webserver = require('gulp-webserver');
var gutil = require('gulp-util');
var source = require('vinyl-source-stream');
var watchify = require('watchify');
var browserify = require('browserify');
var reactify = require('reactify');
var rename = require('gulp-rename');

gulp.task('default', ['watchScripts', 'webserver']);

gulp.task('webserver', function() {
  gulp.src('./')
    .pipe(webserver({
      livereload: true,
      port: 9191,
      host: '0.0.0.0',
      directoryListing: false,
      open: false
    }));
});


function scripts(watch) {
    var bundler, rebundle;
    bundler = browserify({
        entries: ['./index.jsx'],
        extensions: ['.js'],
        debug: true,
        paths: ['./'],
        cache: {},
        packageCache: {},
        fullPaths: watch
    });
    if(watch) {
        bundler = watchify(bundler);
    };
    bundler.transform(reactify);
    rebundle = function() {
        var stream = bundler.bundle();
        return stream.pipe(source('index.js'))
            .pipe(rename('bundle.js'))
            .pipe(gulp.dest('./'));
    };
    bundler.on('log', gutil.log);
    bundler.on('update', function() {
        gutil.log('watchify update launched');
        rebundle();
    });
    return rebundle();
};

gulp.task('watchScripts', function() {
    return scripts(true);
});

