var React = require('react');
var Icon = require('./icon.js');

var RestartButton = React.createClass({
    
    render: function() {
        return (
            <button type="button" data-player="restart" onClick={this.props.handleSeek}>
                <Icon name="icon-restart" />
                <span className="sr-only">Restart</span>
            </button>
        );
    }

});

var RewindButton = React.createClass({
    
    render: function() {
        return (
            <button type="button" data-player="rewind" onClick={this.props.handleRewind}>
                <Icon name="icon-rewind"/>
                <span className="sr-only">Rewind 10 secs</span>
            </button>
        );
    }

});

var PlayButton = React.createClass({

    handleToggle: function() {
        var node = this.getDOMNode();
        this.props.handleTogglePlayback();
        setTimeout(function() { node.focus(); }, 100);
    },

    render: function() {
        var name = this.props.playing ? "icon-pause" : "icon-play";
        var state = this.props.playing ? "pause" : "play";
        return (
            <button type="button" data-player={state} onClick={this.props.handleTogglePlayback}>
                <Icon name={name} />
            </button>
        );
    }

});

var FastForwardButton = React.createClass({
    
    render: function() {
        return (
            <button type="button" data-player="fast-forward" onClick={this.props.handleForward}>
                <Icon name="icon-fast-forward" />
                <span className="sr-only">Forward 10 secs</span>
            </button>
        );
    }
});

var MuteButton = React.createClass({

    toggleMute: function() {
        this.props.toggleMute(!this.props.muted);
    },

    render: function() {
        var name;
        if(this.props.muted) {
            name = "icon-muted"
        } else {
            name = "icon-volume"
        };
        return (
            <button type="button" data-player="mute" onClick={this.toggleMute}>
                <Icon name={name} className={name} />
            </button>
        );
    }
});

var VolumeControl = React.createClass({

    changeVolume: function(e) {
        this.props.setVolume(e.target.value);
    },

    render: function() {
        return (
            <input id="volume" className="player-volume" onChange={this.changeVolume} value={this.props.volumeLevel} type="range" min="0" max="1" defaultValue="0.5" step="0.01"
                data-player="volume" />
        );
    }
});

var FullScreenButton = React.createClass({

    toggleFullScreen: function(event) {
        this.props.onToggleFullScreen(event);
    },

    render: function() {
        var name;
        if(this.props.fullScreen) {
            name = "icon-exit-fullscreen"
        } else {
            name = "icon-enter-fullscreen"
        };
        return (
            <button type="button" data-player="fullscreen" onClick={this.toggleFullScreen}>
                <Icon name={name} />
            </button>
        );
    }

});

module.exports = {
    RestartButton: RestartButton,
    RewindButton: RewindButton,
    PlayButton: PlayButton,
    FastForwardButton: FastForwardButton,
    MuteButton: MuteButton,
    VolumeControl: VolumeControl,
    FullScreenButton: FullScreenButton,
};
